# sample_one.py
 
import wx

# class MyFrame
# class MyListCtrl
# class MyApp

#---------------------------------------------------------------------------

data = [
    ['Noel', 'Louise'],
    ['Martin', 'Justine'],
    ['Antoine', 'Eloise'],
    ['Jenifer', 'Marguerite'],
    ['Marc', 'Sophie'],
    ['Etienne', 'Edith'],
    ['Jhon', 'Doe']
    ]

#---------------------------------------------------------------------------

class MyFrame(wx.Frame):
    def __init__(self, title):
        wx.Frame.__init__(self, None, -1,
                          title,
                          size=(420, 200),
                          pos=(400, 448))

        #------------
        
        self.SetIcon(wx.Icon('icons/wxwin.ico'))
        self.SetMinSize((420, 200))

        #------------
        
        self.listCtrl = MyListCtrl(self, data)

#---------------------------------------------------------------------------

class MyListCtrl(wx.ListCtrl):
    def __init__(self, parent, data):
        wx.ListCtrl.__init__(self, parent, -1,
                             style=wx.LC_REPORT |
                                   wx.LC_VIRTUAL |
                                   wx.LC_HRULES |
                                   wx.LC_VRULES)

        #------------

        self.SetBackgroundColour("white")
        
        #------------
        
        self.items = data
        print("Items :",  self.items)
        
        #------------
        
        self.InsertColumn(0, "Firstname")
        self.InsertColumn(1, "Surname")

        self.SetColumnWidth(0, 100)  # (0, -2)
        self.SetColumnWidth(1, 300)  # (1, -2)

        #------------
        
        self.SetItemCount(len(data))
        
    #-----------------------------------------------------------------------
        
    def OnGetItemText(self, item, col):
        """
        ...
        """
        
        return data[item][col]

#---------------------------------------------------------------------------

class MyApp(wx.App):    
    def OnInit(self):

        #------------

        frame = MyFrame("Sample one")
        self.SetTopWindow(frame)
        frame.Show(True)

        return True
    
#---------------------------------------------------------------------------

def main():
    app = MyApp(False)
    app.MainLoop()

#---------------------------------------------------------------------------

if __name__ == "__main__" :
    main()
    
