# sample_six.py
 
import wx
import wx.lib.mixins.listctrl as listmix

# class MyFrame
# class MyListCtrl
# class MyApp

#---------------------------------------------------------------------------

data = [
    ['Noel', 'Louise'],
    ['Martin', 'Justine'],
    ['Antoine', 'Eloise'],
    ['Jenifer', 'Marguerite'],
    ['Marc', 'Sophie'],
    ['Etienne', 'Edith'],
    ['Jhon', 'Doe']
    ]

#---------------------------------------------------------------------------

class MyFrame(wx.Frame):
    def __init__(self, title):
        wx.Frame.__init__(self, None, -1,
                          title,
                          size=(420, 200),
                          pos=(400, 448))

        #------------
        
        self.SetIcon(wx.Icon('icons/wxwin.ico'))
        self.SetMinSize((420, 200))

        #------------
        
        self.listCtrl = MyListCtrl(self, data)

#---------------------------------------------------------------------------

class MyListCtrl(wx.ListCtrl,
                 listmix.ListCtrlAutoWidthMixin):
    def __init__(self, parent, data):
        wx.ListCtrl.__init__(self, parent, -1,
                             style=wx.LC_REPORT |
                                   wx.LC_VIRTUAL |
                                   wx.LC_HRULES |
                                   wx.LC_VRULES)

        #------------

        # Initialize the listCtrl auto width.        
        listmix.ListCtrlAutoWidthMixin.__init__(self)

        #------------

        self.prevColumn = False
        self.sortAcend = True

        #------------

        self.attr1 = wx.ItemAttr()
        self.attr1.SetBackgroundColour("#e6ffd0")

        self.attr2 = wx.ItemAttr()
        self.attr2.SetBackgroundColour("#f0f0f0")

        self.attr3 = wx.ItemAttr()
        self.attr3.SetBackgroundColour("#fffccc")
        
        #------------
        
        self.items = data
        print("Items :",  self.items)
        
        #------------
        
        self.InsertColumn(0, "Firstname")
        self.InsertColumn(1, "Surname")

        self.SetColumnWidth(0, 100)  # (0, -2)
        self.SetColumnWidth(1, 300)  # (1, -2)

        #------------
        
        self.SetItemCount(len(data))

        #------------

        self.Bind(wx.EVT_LIST_COL_CLICK, self.Sort)
        
    #-----------------------------------------------------------------------
        
    def OnGetItemText(self, item, col):
        """
        ...
        """
        
        return data[item][col]


    def OnGetItemAttr(self, item):
        """
        ...
        """
        
        if item % 4 == 0:
            return self.attr1
        elif item % 4 == 1:
            return self.attr2
        elif item % 4 == 2:
            return self.attr3
        else:
            return None


    def Sort(self, event):
        """
        ...
        """
        
        col = event.GetColumn()

        #------------
        
        if col != self.prevColumn:
            self.sortAcend = True
        else:
            if self.sortAcend:
                self.sortAcend = None
            else:
                self.sortAcend = True
        if self.sortAcend:
            self.items.sort(key=lambda x: x[col])
        else:
            self.items.reverse()

        self.prevColumn = col

        #------------
        
        self.DeleteAllItems()

        #------------
        
        self.SetItemCount(len(self.items))
        
#---------------------------------------------------------------------------

class MyApp(wx.App):    
    def OnInit(self):

        #------------

        frame = MyFrame("Sample six (highlighted row)")
        self.SetTopWindow(frame)
        frame.Show(True)

        return True
    
#---------------------------------------------------------------------------

def main():
    app = MyApp(False)
    app.MainLoop()

#---------------------------------------------------------------------------

if __name__ == "__main__" :
    main()
    
